# Administration Reference

## fileserver

Purpose

Initializes the File Server component of the fs process

Synopsis

    fileserver [-d <debug level>]  [-p <number of processes>]
               [-spare <number of spare blocks>]
               [-pctspare <percentage spare>]  [-b <buffers>]
               [-l <large vnodes>]  [-s <small  nodes>]
               [-vc <volume cachesize>]  [-w <call back wait interval>]
               [-cb <number of call backs>]
               [-banner (print banner every 10 minutes)]
               [-novbc (whole volume cbs disabled)]
               [-implicit <admin mode bits: rlidwka>]
               [-hr <number of hours between refreshing the host cps>]
               [-busyat <redirect clients when queue > n>]
               [-rxpck <number of rx extra packets>]
               [-rxdbg (enable rx debugging)]
               [-rxdbge (enable rxevent debugging)]
               [-m <min percentage spare in partition>]
               [-lock (keep fileserver from swapping)]
               [-L (large server conf)]  [-S (small server conf)]
               [-k <stack size>]  [-realm <Kerberos realm name>]
               [-udpsize <size of socket buffer in bytes>]
               [-enable_peer_stats]  [-enable_process_stats]
               [-help]

This command does not use the syntax conventions of the AFS command suites. Provide the command name and all option names in full.

Description

The fileserver command initializes the File Server component of the fs process. In the conventional configuration, its binary file is located in the /usr/afs/bin directory on a file server machine.

The fileserver command is not normally issued at the command shell prompt, but rather placed into a database server machine's /usr/afs/local/BosConfig file with the bos create command. If it is ever issued at the command shell prompt, the issuer must be logged onto a file server machine as the local superuser root.

The File Server creates the /usr/afs/logs/FileLog log file as it initializes, if the file does not already exist. It does not write a detailed trace by default, but use the -d option to increase the amount of detail. Use the bos getlog command to display the contents of the log file.

The command's arguments enable the administrator to control many aspects of the File Server's performance, as detailed in the Options section. By default the fileserver command sets values for many arguments that are suitable for a medium-sized file server machine. To set values suitable for a small or large file server machine, use the -S or -L flag respectively. The following list describes the parameters and corresponding argument for which the fileserver command sets default values, and Table 1 summarizes the setting for each of the three machine sizes.

- The maximum number of lightweight processes (LWPs) the File Server uses to handle requests for data; corresponds to the -p argument. The File Server always uses a minimum of 32 KB for these processes.

- The maximum number of directory blocks the File Server caches in memory; corresponds to the -b argument. Each cached directory block (buffer) consumes 2,092 bytes of memory.

- The maximum number of large vnodes the File Server caches in memory for tracking directory elements; corresponds to the -l argument. Each large vnode consumes 292 bytes of memory.

- The maximum number of small vnodes the File Server caches in memory for tracking file elements; corresponds to the -s argument. Each small vnode consumes 100 bytes of memory.

- The maximum volume cache size, which determines how many volumes the File Server can cache in memory before having to retrieve data from disk; corresponds to the -vc argument.

- The maximum number of callback structures the File Server caches in memory; corresponds to the -cb argument. Each callback structure consumes 16 bytes of memory.

- The maximum number of Rx packets the File Server uses; corresponds to the -rxpck argument. Each packet consumes 1544 bytes of memory.

Table 1. File Server configuration parameters

Parameter (Argument) | Small configuration (-S) | Medium configuration (default) | Large configuration (-L)
Number of LWPs (-p) | 6 | 9 | 12
Number of cached directory blocks (-b) | 70 | 90 | 120
Number of cached large vnodes (-l) | 200 | 400 | 600
Number of cached small vnodes (-s) | 200 | 400 | 600
Maximum volume cache size (-vc) | 200 | 400 | 600
Number of callbacks (-cb) | 20,000 | 60,000 | 64,000
Number of Rx packets (-rxpck) | 100 | 150 | 200

To override any of the values, provide the indicated argument (which can be combined with the -S or -L flag).

The amount of memory required for the File Server varies. The approximate default memory usage is 751 KB when the -S flag is used (small configuration), 1.1 MB when all defaults are used (medium configuration), and 1.4 MB when the -L flag is used (large configuration). If additional memory is available, increasing the value of the -cb and -vc arguments can improve File Server performance most directly.

By default, the File Server allows a volume to exceed its quota by 1 MB when an application is writing data to an existing file in a volume that is full. The File Server still does not allow users to create new files in a full volume. To change the default, use one of the following arguments:

- Set the -spare argument to the number of extra kilobytes that the File Server allows as overage. A value of 0 allows no overage.

- Set the -pctspare argument to the percentage of the volume's quota the File Server allows as overage.

By default, the File Server implicitly grants the a (administer) and l (lookup) permissions to the system:administrators on the access control list (ACL) of every directory in the volumes stored on its file server machine. In other words, the group's members can exercise those two permissions even when an entry for the group does not appear on an ACL. To change the set of default permissions, use the -implicit argument.

The File Server maintains a host current protection subgroup (host CPS) for each client machine from which it has received a data access request. Like the CPS for a user, a host CPS lists all of the Protection Database groups to which the machine belongs, and the File Server compares the host CPS to a directory's ACL to determine in what manner users on the machine are authorized to access the directory's contents. When the pts adduser or pts removeuser command is used to change the groups to which a machine belongs, the File Server must recompute the machine's host CPS in order to notice the change. By default, the File Server contacts the Protection Server every two hours to recompute host CPSs, implying that it can take that long for changed group memberships to become effective. To change this frequency, use the -hr argument.

Note: | The AIX operating system does not automatically reserve a part of each partition to avoid the negative consequences that can result when the space on a partition is completely exhausted. Therefore, the AIX version of the File Server creates an 8% disk reserve automatically. To change the percentage, use the -m argument.

The File Server generates the following message when a partition is nearly full:

       No space left on device

Cautions

Do not use the -k and -w arguments, which are intended for use by the AFS Development group only. Changing them from their default values can result in unpredictable File Server behavior. In any case, on many operating systems the File Server uses native threads rather than the LWP threads, so using the -k argument to set the number of LWP threads has no effect.

Do not specify both the -spare and -pctspare arguments. Doing so causes the File Server to exit, leaving an error message in the /usr/afs/logs/FileLog file.

Options that are available only on some system types, such as the -m and -lock options, appear in the output generated by the -help option only on the relevant system type.

Options

-d
  Sets the detail level for the debugging trace written to the /usr/afs/logs/FileLog file. Provide one of the following values, each of which produces an increasingly detailed trace: 0, 1, 5, 25, and 125. The default value of 0 produces only a few messages.

-p
  Sets the number of threads to run. Provide a positive integer. The File Server creates and uses five threads for special purposes, in addition to the number specified (but if this argument specifies the maximum possible number, the File Server automatically uses five of the threads for its own purposes).

  The maximum number of threads can differ in each release of AFS. Consult the IBM AFS Release Notes for the current release.

-spare
  Specifies the number of additional kilobytes an application can store in a volume after the quota is exceeded. Provide a positive integer; a value of 0 prevents the volume from ever exceeding its quota. Do not combine this argument with the -pctspare argument.

-pctspare
  Specifies the amount by which the File Server allows a volume to exceed its quota, as a percentage of the quota. Provide an integer between 0 and 99. A value of 0 prevents the volume from ever exceeding its quota. Do not combine this argument with the -spare argument.

-b
  Sets the number of directory buffers. Provide a positive integer.

-l
  Sets the number of large vnodes available in memory for caching directory elements. Provide a positive integer.

-s
  Sets the number of small vnodes available in memory for caching file elements. Provide a positive integer.

-vc
  Sets the number of volumes the File Server can cache in memory. Provide a positive integer.

-w
  Sets the interval at which the daemon spawned by the File Server performs its maintenance tasks. Do not use this argument; changing the default value can cause unpredictable behavior.

-cb
  Sets the number of callbacks the File Server can track. Provide a positive integer.

-banner
  Prints the following banner to /dev/console about every 10 minutes.

         File Server is running at time.

-novbc
  Prevents the File Server from breaking the callbacks that Cache Managers hold on a volume that the File Server is reattaching after the volume was offline (as a result of the vos restore command, for example). Use of this flag is strongly discouraged.

-implicit
  Defines the set of permissions granted by default to the system:administrators group on the ACL of every directory in a volume stored on the file server machine. Provide one or more of the standard permission letters (rlidwka) and auxiliary permission letters (ABCDEFGH), or one of the shorthand notations for groups of permissions (all, none, read, and write). To review the meaning of the permissions, see the fs setacl reference page.

  Note: | The File Server always implicitly grants the a permission to the system:administrators group, even if you use the none value.

-hr
  Specifies how often the File Server refreshes its knowledge of the machines that belong to protection groups (refreshes the host CPSs for machines). The File Server must update this information to enable users from machines recently added to protection groups to access data for which those machines now have the necessary ACL permissions.

-busyat
  Defines the number of incoming RPCs that can be waiting for a response from the File Server before the File Server returns the error code VBUSY to the Cache Manager that sent the latest RPC. In response, the Cache Manager retransmits the RPC after a delay. This argument prevents the accumulation of so many waiting RPCs that the File Server can never process them all. Provide a positive integer. The default value is 600.

-rxpck
  Controls the number of Rx packets the File Server uses to store data for incoming RPCs that it is currently handling, that are waiting for a response, and for replies that are not yet complete. Provide a positive integer.

-rxdbg
  Writes a trace of the File Server's operations on Rx packets to the file /usr/afs/logs/rx_dbg.

-rxdbge
  Writes a trace of the File Server's operations on Rx events (such as retransmissions) to the file /usr/afs/logs/rx_dbg.

-m
  Specifies the percentage of each AFS server partition that the AIX version of the File Server creates as a reserve. Specify an integer value between 0 and 30; the default is 8%. A value of 0 means that the partition can become completely full, which can have serious negative consequences.

  Note: | This argument is available only on machines running the AIX operating system, and so does not appear in the syntax statement when the -help flag is used on other system types.

-lock
  Prevents any portion of the fileserver binary from being paged (swapped) out of memory on a file server machine running the IRIX operating system.

  Note: | This argument is available only on machines running the IRIX operating system, and so does not appear in the syntax statement when the -help flag is used on other system types.

-L
  Sets values for many arguments in a manner suitable for a large file server machine. Combine this flag with any option except the -S flag; omit both flags to set values suitable for a medium-sized file server machine.

-S
  Sets values for many arguments in a manner suitable for a small file server machine. Combine this flag with any option except the -L flag; omit both flags to set values suitable for a medium-sized file server machine.

-k
  Sets the LWP stack size in units of 1 kilobyte. Do not use this argument, and in particular do not specify a value less than the default of 24.

-realm
  Defines the Kerberos realm name for the File Server to use. If this argument is not provided, it uses the realm name corresponding to the cell listed in the local /usr/afs/etc/ThisCell file.

-udpsize
  Sets the size of the UDP buffer, which is 64 KB by default. Provide a positive integer, preferably larger than the default.

-enable_peer_stats
  Activates the collection of Rx statistics and allocates memory for their storage. For each connection with a specific UDP port on another machine, a separate record is kept for each type of RPC (FetchFile, GetStatus, and so on) sent or received. To display or otherwise access the records, use the Rx Monitoring API.

-enable_process_stats
  Activates the collection of Rx statistics and allocates memory for their storage. A separate record is kept for each type of RPC (FetchFile, GetStatus, and so on) sent or received, aggregated over all connections to other machines. To display or otherwise access the records, use the Rx Monitoring API.

-help
  Prints the online help for this command. All other valid options are ignored.

Examples

The following bos create command creates an fs process on the file server machine fs2.abc.com that uses the large configuration size, and allows volumes to exceed their quota by 10%. Type the command on a single line:

       % bos create -server fs2.abc.com -instance fs -type fs   \
                    -cmd "/usr/afs/bin/fileserver -pctspare 10 \
                    -L" /usr/afs/bin/volserver /usr/afs/bin/salvager

Privilege Required

The issuer must be logged in as the superuser root on a file server machine to issue the command at a command shell prompt. It is conventional instead to create and start the process by issuing the bos create command.

Related Information

BosConfig

FileLog

bos create

bos getlog

fs setacl

salvager

volserver

© IBM Corporation 2000. All Rights Reserved